/*
 * If you want keys other than the X11 function keys (0xFD00 - 0xFFFF)
 * to be mapped below, add them to this array.
 */
static KeySym mappedkeys[] = {
	XK_space,
	XK_m,
	XK_i,
	XK_A,
	XK_B,
	XK_C,
	XK_D,
	XK_E,
	XK_F,
	XK_G,
	XK_H,
	XK_I,
	XK_K,
	XK_J,
	XK_L,
	XK_M,
	XK_N,
	XK_O,
	XK_P,
	XK_Q,
	XK_R,
	XK_S,
	XK_T,
	XK_U,
	XK_V,
	XK_W,
	XK_X,
	XK_Y,
	XK_Z,
	XK_Z,
	XK_0,
	XK_1,
	XK_2,
	XK_3,
	XK_4,
	XK_5,
	XK_6,
	XK_7,
	XK_8,
	XK_9,
	XK_exclam,
	XK_quotedbl,
	XK_numbersign,
	XK_dollar,
	XK_percent,
	XK_ampersand,
	XK_apostrophe,
	XK_parenleft,
	XK_parenright,
	XK_asterisk,
	XK_plus,
	XK_comma,
	XK_minus,
	XK_period,
	XK_slash,
	XK_colon,
	XK_semicolon,
	XK_less,
	XK_equal,
	XK_greater,
	XK_question,
	XK_at,
	XK_bracketleft,
	XK_backslash,
	XK_bracketright,
	XK_asciicircum,
	XK_underscore,
	XK_grave,
	XK_braceleft,
	XK_bar,
	XK_braceright,
	XK_asciitilde,
};

/*
 * State bits to ignore when matching key or button events.  By default,
 * numlock (Mod2Mask) and keyboard layout (SWITCH) are ignored.
 */
static uint ignoremod = Mod2Mask|SWITCH;
static uint forcemousemod = SHIFT;
static uint selmasks[] = {
	[SEL_RECTANGULAR] = ALT,     
};

static Key key[] = {
	/* keysym           mask            string      appkey appcursor */
	{ XK_KP_Home,       SHIFT,          "\033[2J",       0,   -1},
	{ XK_KP_Home,       SHIFT,          "\033[1;2H",     0,   +1},
	{ XK_KP_Home,       ANY,            "\033[H",        0,   -1},
	{ XK_KP_Home,       ANY,            "\033[1~",       0,   +1},
	{ XK_KP_Up,         ANY,            "\033Ox",       +1,    0},
	{ XK_KP_Up,         ANY,            "\033[A",        0,   -1},
	{ XK_KP_Up,         ANY,            "\033OA",        0,   +1},
	{ XK_KP_Down,       ANY,            "\033Or",       +1,    0},
	{ XK_KP_Down,       ANY,            "\033[B",        0,   -1},
	{ XK_KP_Down,       ANY,            "\033OB",        0,   +1},
	{ XK_KP_Left,       ANY,            "\033Ot",       +1,    0},
	{ XK_KP_Left,       ANY,            "\033[D",        0,   -1},
	{ XK_KP_Left,       ANY,            "\033OD",        0,   +1},
	{ XK_KP_Right,      ANY,            "\033Ov",       +1,    0},
	{ XK_KP_Right,      ANY,            "\033[C",        0,   -1},
	{ XK_KP_Right,      ANY,            "\033OC",        0,   +1},
	{ XK_KP_Prior,      SHIFT,          "\033[5;2~",     0,    0},
	{ XK_KP_Prior,      ANY,            "\033[5~",       0,    0},
	{ XK_KP_Begin,      ANY,            "\033[E",        0,    0},
	{ XK_KP_End,        CONTROL,        "\033[J",       -1,    0},
	{ XK_KP_End,        CONTROL,        "\033[1;5F",    +1,    0},
	{ XK_KP_End,        SHIFT,          "\033[K",       -1,    0},
	{ XK_KP_End,        SHIFT,          "\033[1;2F",    +1,    0},
	{ XK_KP_End,        ANY,            "\033[4~",       0,    0},
	{ XK_KP_Next,       SHIFT,          "\033[6;2~",     0,    0},
	{ XK_KP_Next,       ANY,            "\033[6~",       0,    0},
	{ XK_KP_Insert,     SHIFT,          "\033[2;2~",    +1,    0},
	{ XK_KP_Insert,     SHIFT,          "\033[4l",      -1,    0},
	{ XK_KP_Insert,     CONTROL,        "\033[L",       -1,    0},
	{ XK_KP_Insert,     CONTROL,        "\033[2;5~",    +1,    0},
	{ XK_KP_Insert,     ANY,            "\033[4h",      -1,    0},
	{ XK_KP_Insert,     ANY,            "\033[2~",      +1,    0},
	{ XK_KP_Delete,     CONTROL,        "\033[M",       -1,    0},
	{ XK_KP_Delete,     CONTROL,        "\033[3;5~",    +1,    0},
	{ XK_KP_Delete,     SHIFT,          "\033[2K",      -1,    0},
	{ XK_KP_Delete,     SHIFT,          "\033[3;2~",    +1,    0},
	{ XK_KP_Delete,     ANY,            "\033[P",       -1,    0},
	{ XK_KP_Delete,     ANY,            "\033[3~",      +1,    0},
	{ XK_KP_Multiply,   ANY,            "\033Oj",       +2,    0},
	{ XK_KP_Add,        ANY,            "\033Ok",       +2,    0},
	{ XK_KP_Enter,      ANY,            "\033OM",       +2,    0},
	{ XK_KP_Enter,      ANY,            "\r",           -1,    0},
	{ XK_KP_Subtract,   ANY,            "\033Om",       +2,    0},
	{ XK_KP_Decimal,    ANY,            "\033On",       +2,    0},
	{ XK_KP_Divide,     ANY,            "\033Oo",       +2,    0},
	{ XK_KP_0,          ANY,            "\033Op",       +2,    0},
	{ XK_KP_1,          ANY,            "\033Oq",       +2,    0},
	{ XK_KP_2,          ANY,            "\033Or",       +2,    0},
	{ XK_KP_3,          ANY,            "\033Os",       +2,    0},
	{ XK_KP_4,          ANY,            "\033Ot",       +2,    0},
	{ XK_KP_5,          ANY,            "\033Ou",       +2,    0},
	{ XK_KP_6,          ANY,            "\033Ov",       +2,    0},
	{ XK_KP_7,          ANY,            "\033Ow",       +2,    0},
	{ XK_KP_8,          ANY,            "\033Ox",       +2,    0},
	{ XK_KP_9,          ANY,            "\033Oy",       +2,    0},
	{ XK_Up,            SHIFT,          "\033[1;2A",     0,    0},
	{ XK_Up,            ALT,            "\033[1;3A",     0,    0},
	{ XK_Up,         SHIFT|ALT,         "\033[1;4A",     0,    0},
	{ XK_Up,            CONTROL,        "\033[1;5A",     0,    0},
	{ XK_Up,      SHIFT|CONTROL,        "\033[1;6A",     0,    0},
	{ XK_Up,       CONTROL|ALT,         "\033[1;7A",     0,    0},
	{ XK_Up,SHIFT|CONTROL|ALT,		    "\033[1;8A",  0,    0},
	{ XK_Up,            ANY,            "\033[A",        0,   -1},
	{ XK_Up,            ANY,            "\033OA",        0,   +1},
	{ XK_Down,          SHIFT,          "\033[1;2B",     0,    0},
	{ XK_Down,          ALT,            "\033[1;3B",     0,    0},
	{ XK_Down,       SHIFT|ALT,         "\033[1;4B",     0,    0},
	{ XK_Down,          CONTROL,        "\033[1;5B",     0,    0},
	{ XK_Down,    SHIFT|CONTROL,        "\033[1;6B",     0,    0},
	{ XK_Down,     CONTROL|ALT,         "\033[1;7B",     0,    0},
	{ XK_Down,SHIFT|CONTROL|ALT,        "\033[1;8B",0,    0},
	{ XK_Down,          ANY,            "\033[B",        0,   -1},
	{ XK_Down,          ANY,            "\033OB",        0,   +1},
	{ XK_Left,          SHIFT,          "\033[1;2D",     0,    0},
	{ XK_Left,          ALT,            "\033[1;3D",     0,    0},
	{ XK_Left,       SHIFT|ALT,         "\033[1;4D",     0,    0},
	{ XK_Left,          CONTROL,        "\033[1;5D",     0,    0},
	{ XK_Left,    SHIFT|CONTROL,        "\033[1;6D",     0,    0},
	{ XK_Left,     CONTROL|ALT,         "\033[1;7D",     0,    0},
	{ XK_Left,SHIFT|CONTROL|ALT,        "\033[1;8D",0,    0},
	{ XK_Left,          ANY,            "\033[D",        0,   -1},
	{ XK_Left,          ANY,            "\033OD",        0,   +1},
	{ XK_Right,         SHIFT,          "\033[1;2C",     0,    0},
	{ XK_Right,         ALT,            "\033[1;3C",     0,    0},
	{ XK_Right,      SHIFT|ALT,         "\033[1;4C",     0,    0},
	{ XK_Right,         CONTROL,        "\033[1;5C",     0,    0},
	{ XK_Right,   SHIFT|CONTROL,		"\033[1;6C",     0,    0},
	{ XK_Right,    CONTROL|ALT,			"\033[1;7C",     0,    0},
	{ XK_Right,SHIFT|CONTROL|ALT,       "\033[1;8C",0,   0},
	{ XK_Right,         ANY,            "\033[C",        0,   -1},
	{ XK_Right,         ANY,            "\033OC",        0,   +1},
	{ XK_ISO_Left_Tab,  SHIFT,          "\033[Z",        0,    0},
	{ XK_Return,        ALT,            "\033\r",        0,    0},
	{ XK_Return,        ANY,            "\r",            0,    0},
	{ XK_Insert,        SHIFT,          "\033[4l",      -1,    0},
	{ XK_Insert,        SHIFT,          "\033[2;2~",    +1,    0},
	{ XK_Insert,        CONTROL,        "\033[L",       -1,    0},
	{ XK_Insert,        CONTROL,        "\033[2;5~",    +1,    0},
	{ XK_Insert,        ANY,            "\033[4h",      -1,    0},
	{ XK_Insert,        ANY,            "\033[2~",      +1,    0},
	{ XK_Delete,        CONTROL,        "\033[M",       -1,    0},
	{ XK_Delete,        CONTROL,        "\033[3;5~",    +1,    0},
	{ XK_Delete,        SHIFT,          "\033[2K",      -1,    0},
	{ XK_Delete,        SHIFT,          "\033[3;2~",    +1,    0},
	{ XK_Delete,        ANY,            "\033[P",       -1,    0},
	{ XK_Delete,        ANY,            "\033[3~",      +1,    0},
	{ XK_BackSpace,     NONE,           "\177",          0,    0},
	{ XK_BackSpace,     ALT,            "\033\177",      0,    0},
	{ XK_Home,          SHIFT,          "\033[2J",       0,   -1},
	{ XK_Home,          SHIFT,          "\033[1;2H",     0,   +1},
	{ XK_Home,          ANY,            "\033[H",        0,   -1},
	{ XK_Home,          ANY,            "\033[1~",       0,   +1},
	{ XK_End,           CONTROL,        "\033[J",       -1,    0},
	{ XK_End,           CONTROL,        "\033[1;5F",    +1,    0},
	{ XK_End,           SHIFT,          "\033[K",       -1,    0},
	{ XK_End,           SHIFT,          "\033[1;2F",    +1,    0},
	{ XK_End,           ANY,            "\033[4~",       0,    0},
	{ XK_Prior,         CONTROL,        "\033[5;5~",     0,    0},
	{ XK_Prior,         SHIFT,          "\033[5;2~",     0,    0},
	{ XK_Prior,         ANY,            "\033[5~",       0,    0},
	{ XK_Next,          CONTROL,        "\033[6;5~",     0,    0},
	{ XK_Next,          SHIFT,          "\033[6;2~",     0,    0},
	{ XK_Next,          ANY,            "\033[6~",       0,    0},
	{ XK_F1,            NONE,           "\033OP" ,       0,    0},
	{ XK_F1, /* F13 */  SHIFT,          "\033[1;2P",     0,    0},
	{ XK_F1, /* F25 */  CONTROL,        "\033[1;5P",     0,    0},
	{ XK_F1, /* F37 */  SUPER,          "\033[1;6P",     0,    0},
	{ XK_F1, /* F49 */  ALT,            "\033[1;3P",     0,    0},
	{ XK_F1, /* F61 */  Mod3Mask,       "\033[1;4P",     0,    0},
	{ XK_F2,            NONE,           "\033OQ" ,       0,    0},
	{ XK_F2, /* F14 */  SHIFT,          "\033[1;2Q",     0,    0},
	{ XK_F2, /* F26 */  CONTROL,        "\033[1;5Q",     0,    0},
	{ XK_F2, /* F38 */  SUPER,          "\033[1;6Q",     0,    0},
	{ XK_F2, /* F50 */  ALT,            "\033[1;3Q",     0,    0},
	{ XK_F2, /* F62 */  Mod3Mask,       "\033[1;4Q",     0,    0},
	{ XK_F3,            NONE,           "\033OR" ,       0,    0},
	{ XK_F3, /* F15 */  SHIFT,          "\033[1;2R",     0,    0},
	{ XK_F3, /* F27 */  CONTROL,        "\033[1;5R",     0,    0},
	{ XK_F3, /* F39 */  SUPER,          "\033[1;6R",     0,    0},
	{ XK_F3, /* F51 */  ALT,            "\033[1;3R",     0,    0},
	{ XK_F3, /* F63 */  Mod3Mask,       "\033[1;4R",     0,    0},
	{ XK_F4,            NONE,           "\033OS" ,       0,    0},
	{ XK_F4, /* F16 */  SHIFT,          "\033[1;2S",     0,    0},
	{ XK_F4, /* F28 */  CONTROL,        "\033[1;5S",     0,    0},
	{ XK_F4, /* F40 */  SUPER,          "\033[1;6S",     0,    0},
	{ XK_F4, /* F52 */  ALT,            "\033[1;3S",     0,    0},
	{ XK_F5,            NONE,           "\033[15~",      0,    0},
	{ XK_F5, /* F17 */  SHIFT,          "\033[15;2~",    0,    0},
	{ XK_F5, /* F29 */  CONTROL,        "\033[15;5~",    0,    0},
	{ XK_F5, /* F41 */  SUPER,          "\033[15;6~",    0,    0},
	{ XK_F5, /* F53 */  ALT,            "\033[15;3~",    0,    0},
	{ XK_F6,            NONE,           "\033[17~",      0,    0},
	{ XK_F6, /* F18 */  SHIFT,          "\033[17;2~",    0,    0},
	{ XK_F6, /* F30 */  CONTROL,        "\033[17;5~",    0,    0},
	{ XK_F6, /* F42 */  SUPER,          "\033[17;6~",    0,    0},
	{ XK_F6, /* F54 */  ALT,            "\033[17;3~",    0,    0},
	{ XK_F7,            NONE,           "\033[18~",      0,    0},
	{ XK_F7, /* F19 */  SHIFT,          "\033[18;2~",    0,    0},
	{ XK_F7, /* F31 */  CONTROL,        "\033[18;5~",    0,    0},
	{ XK_F7, /* F43 */  SUPER,          "\033[18;6~",    0,    0},
	{ XK_F7, /* F55 */  ALT,            "\033[18;3~",    0,    0},
	{ XK_F8,            NONE,           "\033[19~",      0,    0},
	{ XK_F8, /* F20 */  SHIFT,          "\033[19;2~",    0,    0},
	{ XK_F8, /* F32 */  CONTROL,        "\033[19;5~",    0,    0},
	{ XK_F8, /* F44 */  SUPER,          "\033[19;6~",    0,    0},
	{ XK_F8, /* F56 */  ALT,            "\033[19;3~",    0,    0},
	{ XK_F9,            NONE,           "\033[20~",      0,    0},
	{ XK_F9, /* F21 */  SHIFT,          "\033[20;2~",    0,    0},
	{ XK_F9, /* F33 */  CONTROL,        "\033[20;5~",    0,    0},
	{ XK_F9, /* F45 */  SUPER,          "\033[20;6~",    0,    0},
	{ XK_F9, /* F57 */  ALT,            "\033[20;3~",    0,    0},
	{ XK_F10,           NONE,           "\033[21~",      0,    0},
	{ XK_F10, /* F22 */ SHIFT,          "\033[21;2~",    0,    0},
	{ XK_F10, /* F34 */ CONTROL,        "\033[21;5~",    0,    0},
	{ XK_F10, /* F46 */ SUPER,          "\033[21;6~",    0,    0},
	{ XK_F10, /* F58 */ ALT,            "\033[21;3~",    0,    0},
	{ XK_F11,           NONE,           "\033[23~",      0,    0},
	{ XK_F11, /* F23 */ SHIFT,          "\033[23;2~",    0,    0},
	{ XK_F11, /* F35 */ CONTROL,        "\033[23;5~",    0,    0},
	{ XK_F11, /* F47 */ SUPER,          "\033[23;6~",    0,    0},
	{ XK_F11, /* F59 */ ALT,            "\033[23;3~",    0,    0},
	{ XK_F12,           NONE,           "\033[24~",      0,    0},
	{ XK_F12, /* F24 */ SHIFT,          "\033[24;2~",    0,    0},
	{ XK_F12, /* F36 */ CONTROL,        "\033[24;5~",    0,    0},
	{ XK_F12, /* F48 */ SUPER,          "\033[24;6~",    0,    0},
	{ XK_F12, /* F60 */ ALT,            "\033[24;3~",    0,    0},
	{ XK_F13,           NONE,           "\033[1;2P",     0,    0},
	{ XK_F14,           NONE,           "\033[1;2Q",     0,    0},
	{ XK_F15,           NONE,           "\033[1;2R",     0,    0},
	{ XK_F16,           NONE,           "\033[1;2S",     0,    0},
	{ XK_F17,           NONE,           "\033[15;2~",    0,    0},
	{ XK_F18,           NONE,           "\033[17;2~",    0,    0},
	{ XK_F19,           NONE,           "\033[18;2~",    0,    0},
	{ XK_F20,           NONE,           "\033[19;2~",    0,    0},
	{ XK_F21,           NONE,           "\033[20;2~",    0,    0},
	{ XK_F22,           NONE,           "\033[21;2~",    0,    0},
	{ XK_F23,           NONE,           "\033[23;2~",    0,    0},
	{ XK_F24,           NONE,           "\033[24;2~",    0,    0},
	{ XK_F25,           NONE,           "\033[1;5P",     0,    0},
	{ XK_F26,           NONE,           "\033[1;5Q",     0,    0},
	{ XK_F27,           NONE,           "\033[1;5R",     0,    0},
	{ XK_F28,           NONE,           "\033[1;5S",     0,    0},
	{ XK_F29,           NONE,           "\033[15;5~",    0,    0},
	{ XK_F30,           NONE,           "\033[17;5~",    0,    0},
	{ XK_F31,           NONE,           "\033[18;5~",    0,    0},
	{ XK_F32,           NONE,           "\033[19;5~",    0,    0},
	{ XK_F33,           NONE,           "\033[20;5~",    0,    0},
	{ XK_F34,           NONE,           "\033[21;5~",    0,    0},
	{ XK_F35,           NONE,           "\033[23;5~",    0,    0},
};
